package com.trs.components.wcm.content.swf;

import com.trs.components.wcm.content.persistent.Document;
import com.trs.infra.common.WCMException;
import com.trs.infra.persistent.BaseObj;
import com.trs.infra.persistent.listener.IObjectLCListenerOnAdd;
import com.trs.infra.persistent.listener.IObjectLCListenerOnModify;
import com.trs.infra.support.config.ConfigServer;
import com.trs.infra.support.file.FilesMan;
import com.trs.util.swf.SWFCreator;

public class DocumentListenerForFileToSWF implements IObjectLCListenerOnAdd,
        IObjectLCListenerOnModify {
    private static org.apache.log4j.Logger logger = org.apache.log4j.Logger
            .getLogger(DocumentListenerForFileToSWF.class);

    public DocumentListenerForFileToSWF() {
        // TODO Auto-generated constructor stub
    }

    public void notifyOnModifyObj(BaseObj _oObjModified, int _nEventType)
            throws WCMException {
        if (!(_oObjModified instanceof Document)) {
            logger.error("Listener[" + getClass() + "]ܼ["
                    + _oObjModified.getClass() + "]޸ģ");
            return;
        }

        Document document = (Document) _oObjModified;
        if (document.isChangeProperty("DOCTYPE")) {
            int nNewDocType = document.getNewPropertyAsInt("DocType", 0);
            // ĵ޸Ϊⲿļ
            if (nNewDocType == Document.DOC_TYPE_FILE) {
                convertToSWF(document,
                        document.getNewPropertyAsString("DocFileName"));
            }

        } else if (document.getType() == Document.DOC_TYPE_FILE) {
            // ϴļ
            if (document.isChangeProperty("DocFileName")) {
                convertToSWF(document,
                        document.getNewPropertyAsString("DocFileName"));
            }
        }
    }

    public void notifyOnAddObj(BaseObj _oObjAdded) throws WCMException {
        if (!(_oObjAdded instanceof Document)) {
            logger.error("Listener[" + getClass() + "]ܼ["
                    + _oObjAdded.getClass() + "]");
            return;
        }

        Document document = (Document) _oObjAdded;

        // ⲿļ͵ĵ
        if (document.getType() != Document.DOC_TYPE_FILE) {
            return;
        }

        // ȡҪתļ
        String sFileName = document.getPropertyAsString("DOCFILENAME");
        convertToSWF(document, sFileName);
    }

    /**
     * @param _document
     * @param _sFileName
     * @throws WCMException
     */
    private void convertToSWF(Document _document, String _sFileName)
            throws WCMException {
        String sAbsoluteFileName = FilesMan.getFilesMan().mapFilePath(
                _sFileName, FilesMan.PATH_LOCAL)
                + _sFileName;

        // ù߽ת
        try {
            SWFCreator oSwfCreator = new SWFCreator(sAbsoluteFileName);

            // ʼصĲOpenOffice˿ںSWFToolsĿ¼
            oSwfCreator.m_nServicePort = Integer.parseInt(ConfigServer
                    .getServer().getSysConfigValue("OPEN_OFFCIE_PORT", "8100"));
            oSwfCreator.m_sSWFToollsPath = ConfigServer.getServer()
                    .getSysConfigValue("SWF_TOOLS_PATH",
                            oSwfCreator.m_sSWFToollsPath);

            // ת̨߳
            oSwfCreator.start();
        } catch (Throwable e) {
            logger.error(
                    "Fail to convert the document " + _document + " file!", e);
        }
    }

}
